# we ship the 1.4.2 docs for now.
%define docversion 1.4.2
%define speechtoolsversion %version
%define oldstlibname %mklibname -d speech_tools %major
%define oldstdevname %mklibname -d -s speech_tools
%define major 2.1.1
%define libname %mklibname speech_tools %major
%define stringmajor 1.2
%define libnamestring %mklibname eststring %stringmajor
%define oldlibname %mklibname speech_tools 1
%define libnamedevel %mklibname speech_tools -d

Summary:	A free speech synthesizer 
Name:		festival
Version:	2.1
Release:	%mkrel 2
License:	BSD
Group:		Sound
URL:		http://www.cstr.ed.ac.uk/projects/festival/
Source:		http://festvox.org/packed/%{name}/%{version}/%{name}-%{version}-release.tar.xz
Source1:	http://festvox.org/packed/%{name}/%{version}/speech_tools-%{speechtoolsversion}-release.tar.gz
Source2:	http://festvox.org/packed/%{name}/%{docversion}/festdoc-%{docversion}.tar.bz2
Source3:	siteinit.scm
Source4:	sitevars.scm
Patch0:		festival-1.4.1-fsstnd.patch
Patch1:		festival-2.1-nitech-american.patch
Patch2: 	festival_buildroot.patch
Patch3: 	festival.gcc47.patch
Patch5: 	festival-1.96-speechtools-rateconvtrivialbug.patch
Patch6:		festival-2.1-speechtools-linklibswithotherlibs.patch
Patch7:		festival-1.96-speechtools-ohjeezcxxisnotgcc.patch
Patch8:		festival-1.96-speechtools-shared-build.patch
Patch10:	festival-1.96-findspeechtools.patch
Patch11:	festival-1.96-main-shared-build.patch
Patch12:	festival-2.1-bettersonamehack.patch
Patch15:	festival-finnish.patch
Patch16:	festival-1.96-etcsiteinit.patch
Patch17:	speech_tools-1.2.96-fix-str-fmt.patch
Patch18:	festival-2.1-mga-alsa-near-rates.patch
BuildRequires:	perl
BuildRequires:	ncurses-devel

%description
Festival is a general multi-lingual speech synthesis system developed
at CSTR. It offers a full text to speech system with various APIs, as
well as an environment for development and research of speech synthesis
techniques. It is written in C++ with a Scheme-based command interpreter
for general control.

%package	devel
Summary:	Static libraries and headers for %{name} text to speech
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	termcap-devel

%description	devel
Festival is a general multi-lingual speech synthesis system developed
at CSTR. It offers a full text to speech system with various APIs, as
well as an environment for development and research of speech synthesis
techniques. It is written in C++ with a Scheme-based command interpreter
for general control.

This package contains the libraries and includes files necessary to develop
applications using %{name}.

 
%prep
%setup -q -a 1 -a 2 -n %{name}
%patch0 -p1 -b .fsstnd
%patch1 -p1 
%patch2 -p1 -b .buildroot
%patch3 -p0 -b .gcc
%patch5 -p1 -b .rateconvtrivialbug
%patch6 -p1 -b .linklibswithotherlibs
%patch7 -p1 -b .cxx
%patch8 -p1 -b .shared
%patch10 -p1 
%patch11 -p1 
%patch12 -p1 -b .bettersoname
%patch15 -p1 
%patch16 -p1 
%patch17 -p0
%patch18 -p1 -b .nearrates
# zero length
rm festdoc-1.4.2/speech_tools/doc/index_html.jade
rm festdoc-1.4.2/speech_tools/doc/examples_gen/error_example_section.sgml
rm festdoc-1.4.2/speech_tools/doc/tex_stuff.jade

perl -pi -e '/^REQUIRED_LIBRARY_DIR/ and s,/usr/lib,%{_libdir},' config/project.mak


%build

# build speech tools (and libraries)
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$(pwd)/speech_tools/lib
cd speech_tools
  %configure2_5x
  # -fPIC 'cause we're building shared libraries and it doesn't hurt
  # -fno-strict-aliasing because of a couple of warnings about code
  #   problems; if $RPM_OPT_FLAGS contains -O2 or above, this puts
  #   it back. Once that problem is gone upstream, remove this for
  #   better optimization.
  make \
    CFLAGS="$RPM_OPT_FLAGS -fPIC -fno-strict-aliasing" \
    CXXFLAGS="$RPM_OPT_FLAGS  -fPIC -fno-strict-aliasing"
cd -

# build the main program
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$(pwd)/src/lib
# instead of doing this, maybe we should patch the make process
# so it looks in the right place explicitly:
export PATH=$(pwd)/bin:$PATH
%configure
make \
  CFLAGS="$RPM_OPT_FLAGS -fPIC" \
  CXXFLAGS="$RPM_OPT_FLAGS -fPIC" 

%check
# all tests must pass
cd speech_tools
#make CFLAGS="$RPM_OPT_FLAGS -fPIC -fno-strict-aliasing" \
#    CXXFLAGS="$RPM_OPT_FLAGS  -fPIC -fno-strict-aliasing" test | grep -v INCORRECT
cd ..

%install
# install speech tools libs, binaries, and include files
pushd speech_tools

  make INSTALLED_LIB=$RPM_BUILD_ROOT%{_libdir} make_installed_lib_shared
  # no thanks, static libs.
  rm -f $RPM_BUILD_ROOT%{_libdir}/*.a

  make INSTALLED_BIN=$RPM_BUILD_ROOT%{_bindir} make_installed_bin_static
  # this list of the useful programs in speech_tools comes from
  # upstream developer Alan W. Black; the other stuff is to be removed.
  pushd $RPM_BUILD_ROOT%{_bindir}
    ls |
    grep -Evw "ch_wave|ch_track|na_play|na_record|wagon|wagon_test" |
    grep -Evw "make_wagon_desc|pitchmark|pm|sig2fv|wfst_build" |
    grep -Evw "wfst_run|wfst_run" |
    xargs rm
  popd

  pushd include
    for d in $( find . -type d | grep -v win32 ); do
      make -w -C $d INCDIR=$RPM_BUILD_ROOT%{_includedir}/EST/$d install_incs
    done  
  popd

popd


install -d %{buildroot}%{_datadir}/%{name}/{voices/english,dicts}

# bin
make INSTALLED_BIN=$RPM_BUILD_ROOT%{_bindir} make_installed_bin_static
install -m 755 bin/text2wave $RPM_BUILD_ROOT%{_bindir}
install -m 755 examples/saytime $RPM_BUILD_ROOT%{_bindir}

# install the shared library
cp -a src/lib/libFestival.so* $RPM_BUILD_ROOT%{_libdir}

# devel
mkdir -p $RPM_BUILD_ROOT%{_includedir}/%{name}
install src/include/*.h %{buildroot}%{_includedir}/%{name}

# data
cp -r lib config examples %{buildroot}%{_datadir}/%{name}
find %{buildroot}%{_datadir}/%{name} -name Makefile -exec rm \{\} \;

# man pages
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
cp -a doc/*.1 $RPM_BUILD_ROOT%{_mandir}/man1

# lib: the bulk of the program -- the scheme stuff and so on
pushd lib
  mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/lib
  for f in *.scm %{name}.el *.ent *.gram *.dtd *.ngrambin speech.properties ; do
    install -m 644 $f $RPM_BUILD_ROOT%{_datadir}/%{name}/lib/
  done
  mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/lib/multisyn/
  install -m 644 multisyn/*.scm $RPM_BUILD_ROOT%{_datadir}/%{name}/lib/multisyn/
popd 

mv -f %{buildroot}/%{_datadir}/%{name}/lib/etc/unknown_RedHatLinux/audsp %{buildroot}/%{_bindir}
rm -Rf %{buildroot}/%{_datadir}/%{name}/lib/etc/
rm -f %{buildroot}%{_datadir}/%{name}/lib/VCLocalRules


# the actual /etc. :)
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
# use our version of this file
rm $RPM_BUILD_ROOT%{_datadir}/%{name}/lib/siteinit.scm 
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/siteinit.scm
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/sitevars.scm

sed -i -e 's,/projects/%{name}/lib,%{_datadir}/%{name},g' %{buildroot}/%{_datadir}/%{name}/lib/lexicons.scm

%files
%doc ACKNOWLEDGMENTS COPYING INSTALL NEWS README*
%doc festdoc-1.4.2/%{name}/html/*html
%doc festdoc-1.4.2/%{name}/info
%doc festdoc-1.4.2/%{name}/%{name}.ps
%{_bindir}/audsp
%{_bindir}/%{name}
%{_bindir}/%{name}_client
%{_bindir}/%{name}_server
%{_bindir}/%{name}_server_control
%{_bindir}/text2wave
%{_bindir}/saytime
%{_libdir}/libFestival.so.%{version}*
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/lib
%{_datadir}/%{name}/lib/*.scm
%{_datadir}/%{name}/lib/%{name}.el
%{_datadir}/%{name}/lib/*.ent
%{_datadir}/%{name}/lib/*.gram
%{_datadir}/%{name}/lib/*.dtd
%{_datadir}/%{name}/lib/*.ngrambin
%{_datadir}/%{name}/lib/speech.properties
%{_datadir}/%{name}/dicts
%{_datadir}/%{name}/voices
%dir %{_datadir}/%{name}/lib/multisyn
%{_datadir}/%{name}/lib/multisyn/*.scm
%dir %{_datadir}/%{name}/examples
%{_datadir}/%{name}/examples/intro.text
%{_mandir}/man1/*
%config(noreplace) %{_sysconfdir}/%{name}
%doc speech_tools/INSTALL speech_tools/README
%{_bindir}/ch_track
%{_bindir}/ch_wave
%{_bindir}/make_wagon_desc
%{_bindir}/na_play
%{_bindir}/na_record
%{_bindir}/pitchmark
%{_bindir}/pm
%{_bindir}/sig2fv
%{_bindir}/wagon
%{_bindir}/wagon_test
%{_bindir}/wfst_run
%{_bindir}/wfst_build
%{_datadir}/%{name}/examples
%{_libdir}/libestbase.so.%{major}*
%{_libdir}/libestools.so.%{major}*
%{_libdir}/libeststring.so.%{stringmajor}*

%files devel
%doc festdoc-1.4.2/speech_tools
%{_libdir}/libFestival.so
%{_includedir}/%{name}
%{_datadir}/%{name}/config
%{_includedir}/EST
%{_libdir}/libestbase.so
%{_libdir}/libestools.so
%{_libdir}/libeststring.so


%changelog
* Sun Aug 27 2017 adrianomorselli <adrianomorselli> 2.1-2uplos2017
- rebuild for 2017
